Index: /trunk/libf/phytitan/YOMCST.h
===================================================================
--- /trunk/libf/phytitan/YOMCST.h	(revision 101)
+++ /trunk/libf/phytitan/YOMCST.h	(revision 102)
@@ -10,9 +10,9 @@
       REAL RDAY,REA,REPSM,RSIYEA,RSIDAY,ROMEGA
 ! A1.1.bis Constantes concernant l'orbite de la Terre:
-      REAL :: R_ecc, R_peri, R_incl
+      REAL R_ecc, R_peri, R_incl
 ! A1.2 Geoide
       REAL RA,RG,R1SA
 ! A1.3 Radiation
-!     REAL :: RSIGMA,RI0
+!     REAL RSIGMA,RI0
       REAL RSIGMA
 ! A1.4 Thermodynamic gas phase
@@ -31,5 +31,5 @@
 !
       COMMON/YOMCST/RPI ,RCLUM, RHPLA, RKBOL, RNAVO ,RDAY  ,REA         &
-     & ,REPSM ,RSIYEA,RSIDAY,ROMEGA , R_ecc, R_peri, R_incl,            &
+     & ,REPSM ,RSIYEA,RSIDAY,ROMEGA , R_ecc, R_peri, R_incl             &
      & ,RA    ,RG ,R1SA                                                 &
      & ,RSIGMA,R ,RMD   ,RMV   ,RD    ,RV    ,RCPD ,RCPV,RCVD           &
Index: /trunk/libf/phytitan/aaam_bud.F
===================================================================
--- /trunk/libf/phytitan/aaam_bud.F	(revision 101)
+++ /trunk/libf/phytitan/aaam_bud.F	(revision 102)
@@ -2,8 +2,9 @@
      i                   rea,rg,ome,      
      i                   plat,plon,phis,
-     i                   dragu,liftu,phyu,
-     i                   dragv,liftv,phyv,
+     i                   dragu,liftu,clu,
+     i                   dragv,liftv,clv,
      i                   p, u, v)
 c
+      use dimphy
       implicit none
 c======================================================================
@@ -17,6 +18,6 @@
 C    C               ra,rg,romega,
 C    C               rlat,rlon,pphis,
-C    C               zustrdr,zustrli,zustrph,
-C    C               zvstrdr,zvstrli,zvstrph,
+C    C               zustrdr,zustrli,zustrcl,
+C    C               zvstrdr,zvstrli,zvstrcl,
 C    C               paprs,u,v)
 C
@@ -39,8 +40,8 @@
 c dragu---input-R-orodrag stress (zonal)
 c liftu---input-R-orolift stress (zonal)
-c phyu----input-R-Stress total de la physique (zonal)
+c clu-----input-R-Boundary layer stress (zonal)
 c dragv---input-R-orodrag stress (Meridional)
 c liftv---input-R-orolift stress (Meridional)
-c phyv----input-R-Stress total de la physique (Meridional)
+c clv-----input-R-Boundary layer stress (Meridional)
 c p-------input-R-Pressure (Pa) at model half levels
 c u-------input-R-Horizontal wind (m/s)
@@ -78,5 +79,4 @@
 
 #include "dimensions.h"
-#include "dimphy.h"
 c
 c ARGUMENTS
@@ -85,6 +85,6 @@
       REAL rjour,rsec,rea,rg,ome
       REAL plat(nlon),plon(nlon),phis(nlon)
-      REAL dragu(nlon),liftu(nlon),phyu(nlon)             
-      REAL dragv(nlon),liftv(nlon),phyv(nlon)             
+      REAL dragu(nlon),liftu(nlon),clu(nlon)             
+      REAL dragv(nlon),liftv(nlon),clv(nlon)             
       REAL p(nlon,nlev+1), u(nlon,nlev), v(nlon,nlev)
 c
@@ -148,6 +148,6 @@
           ssou(i,1)=dragu(l)+liftu(l)
           ssov(i,1)=dragv(l)+liftv(l)
-          blsu(i,1)=phyu(l)-dragu(l)-liftu(l)
-          blsv(i,1)=phyv(l)-dragv(l)-liftv(l)
+          blsu(i,1)=clu(l)
+          blsv(i,1)=clv(l)
 
         enddo
@@ -162,6 +162,6 @@
           ssou(iim+1,j)=dragu(l+1)+liftu(l+1)
           ssov(iim+1,j)=dragv(l+1)+liftv(l+1)
-          blsu(iim+1,j)=phyu(l+1)-dragu(l+1)-liftu(l+1)
-          blsv(iim+1,j)=phyv(l+1)-dragv(l+1)-liftv(l+1)
+          blsu(iim+1,j)=clu(l+1)
+          blsv(iim+1,j)=clv(l+1)
       zlon(iim+1)=-plon(l+1)*xpi/180.
       zlat(j)=plat(l+1)*xpi/180.
@@ -182,6 +182,6 @@
           ssou(i,j)=dragu(l)+liftu(l)
           ssov(i,j)=dragv(l)+liftv(l)
-          blsu(i,j)=phyu(l)-dragu(l)-liftu(l)
-          blsv(i,j)=phyv(l)-dragv(l)-liftv(l)
+          blsu(i,j)=clu(l)
+          blsv(i,j)=clv(l)
       zlon(i)=plon(l)*xpi/180.
 
@@ -214,6 +214,6 @@
           ssou(i,jjm+1)=dragu(l)+liftu(l)
           ssov(i,jjm+1)=dragv(l)+liftv(l)
-          blsu(i,jjm+1)=phyu(l)-dragu(l)-liftu(l)
-          blsv(i,jjm+1)=phyv(l)-dragv(l)-liftv(l)
+          blsu(i,jjm+1)=clu(l)
+          blsv(i,jjm+1)=clv(l)
       ub(i,jjm+1)=ub(1,jjm+1)                               
       vb(i,jjm+1)=vb(1,jjm+1)                                
@@ -333,5 +333,5 @@
      c      tmou(3)/hadley,tsso(3)/hadley,tbls(3)/hadley 
 100   format(F12.5,15(1x,F12.5))
-c100   format(F12.5,5(1x,F12.5))
+c00   format(F12.5,5(1x,F12.5))
 
       write(iam+1,*)((zs(i,j),i=1,iim),j=1,jjm+1)
Index: /trunk/libf/phytitan/ajsec.F
===================================================================
--- /trunk/libf/phytitan/ajsec.F	(revision 101)
+++ /trunk/libf/phytitan/ajsec.F	(revision 102)
@@ -3,6 +3,8 @@
 !
 ! ADAPTATION GCM POUR CP(T)
-      SUBROUTINE ajsec(paprs, pplay, ppk, tfi, ufi, vfi, nq, qfi,
+      SUBROUTINE ajsec(paprs, pplay, ppk, tfi, ufi, vfi, nq, qfi, 
      .                             d_tfi, d_ufi, d_vfi, d_qfi)
+
+      use dimphy
       IMPLICIT none
 c======================================================================
@@ -23,8 +25,6 @@
 c d_vfi-----output-R-Incrementation du vent meridien
 c d_qfi-----output-R-Incrementation des traceurs
-
 c======================================================================
 #include "dimensions.h"
-#include "dimphy.h"
 #include "YOMCST.h"
       REAL paprs(klon,klev+1), pplay(klon,klev)
@@ -36,7 +36,5 @@
       REAL qfi(klon,klev,nq), d_qfi(klon,klev,nq)
 c
-      INTEGER limbas, limhau ! les couches a ajuster
-ccc      PARAMETER (limbas=klev-3, limhau=klev)
-      PARAMETER (limbas=1, limhau=klev)
+      INTEGER,save :: limbas, limhau ! les couches a ajuster
 c
       REAL zh(klon,klev)
@@ -51,4 +49,7 @@
 c Initialisation:
 c
+      limbas=1
+      limhau=klev
+
       DO k = 1, klev
       DO i = 1, klon
@@ -56,8 +57,8 @@
          d_ufi(i,k) = 0.0
          d_vfi(i,k) = 0.0
-	 d_qfi(i,k,:) = 0.0
+         d_qfi(i,k,:) = 0.0
          zu(i,k)    = ufi(i,k)
          zv(i,k)    = vfi(i,k)
-	 zq(i,k,:)  = qfi(i,k,:)
+         zq(i,k,:)  = qfi(i,k,:)
       ENDDO
       ENDDO
@@ -119,5 +120,5 @@
               zum=0.
               zvm=0.
-	      zqm=0.
+              zqm=0.
               DO k = k1, k2
                 zalpha=zalpha+ABS(zh(i,k)-hm)*zdp(i,k)
@@ -125,14 +126,14 @@
                 zum=zum+ufi(i,k)*zdp(i,k)
                 zvm=zvm+vfi(i,k)*zdp(i,k)
-		do iq=1,nq
-		   zqm(iq)=zqm(iq)+qfi(i,k,iq)*zdp(i,k)
-		enddo
+                do iq=1,nq
+                  zqm(iq)=zqm(iq)+qfi(i,k,iq)*zdp(i,k)
+                enddo
               ENDDO
               zalpha=zalpha/(hm*(paprs(i,k1)-paprs(i,k2+1)))
               zum=zum/(paprs(i,k1)-paprs(i,k2+1))
               zvm=zvm/(paprs(i,k1)-paprs(i,k2+1))
-	      do iq=1,nq
-	         zqm(iq)=zqm(iq)/(paprs(i,k1)-paprs(i,k2+1))
-	      enddo
+              do iq=1,nq
+                zqm(iq)=zqm(iq)/(paprs(i,k1)-paprs(i,k2+1))
+              enddo
 
               IF(zalpha.GT.1.) THEN
@@ -153,5 +154,5 @@
                  zv(i,k)=vfi(i,k)+zalpha*(zvm-vfi(i,k))
                  do iq=1,nq
-		   zq(i,k,iq)=qfi(i,k,iq)+zalpha*(zqm(iq)-qfi(i,k,iq))
+                   zq(i,k,iq)=qfi(i,k,iq)+zalpha*(zqm(iq)-qfi(i,k,iq))
                  enddo
               ENDDO
@@ -187,5 +188,5 @@
          do iq=1,nq
            d_qfi(i,k,iq) = 0.0
-         enddo 
+         enddo
       ENDDO
       ENDDO
@@ -200,5 +201,5 @@
          do iq=1,nq
            d_qfi(i,k,iq) = 0.0
-         enddo 
+         enddo
       ENDDO
       ENDDO
Index: /trunk/libf/phytitan/ballon.F
===================================================================
--- /trunk/libf/phytitan/ballon.F	(revision 101)
+++ /trunk/libf/phytitan/ballon.F	(revision 102)
@@ -2,4 +2,5 @@
      i                   temp, p, u, v, geop)
 
+      use dimphy
       implicit none
 
@@ -94,5 +95,4 @@
 
 #include "dimensions.h"
-#include "dimphy.h"
 #include "YOMCST.h"
 c
@@ -255,4 +255,5 @@
      .                       phi,lam,ubal,vbal,abal)
 
+      use dimphy
       implicit none
 
@@ -283,5 +284,4 @@
 
 #include "dimensions.h"
-#include "dimphy.h"
 #include "YOMCST.h"
 c
@@ -354,4 +354,5 @@
       subroutine pos_implem(phi,lam,ubal,vbal,dt)
 
+      use dimphy
       implicit none
 
@@ -370,5 +371,4 @@
 
 #include "dimensions.h"
-#include "dimphy.h"
 #include "YOMCST.h"
 c
Index: /trunk/libf/phytitan/calchim.F
===================================================================
--- /trunk/libf/phytitan/calchim.F	(revision 101)
+++ /trunk/libf/phytitan/calchim.F	(revision 102)
@@ -2,9 +2,8 @@
      .                   ctemp,cplay,cplev,
      .                   dqyc)
-      implicit none
       
 c-------------------------------------------------
 c  
-c     Introduction d'une routine chimique
+c     Introduction d une routine chimique
 c
 c     Auteur: S. Lebonnois,  01/2000 | 09/2003 
@@ -13,7 +12,7 @@
 c-------------------------------------------------
 c
-
+      use dimphy
+      implicit none
 #include "dimensions.h"
-#include "dimphy.h"
 #include "clesphys.h"
 #include "paramet.h"
Index: /trunk/libf/phytitan/clmain.F
===================================================================
--- /trunk/libf/phytitan/clmain.F	(revision 101)
+++ /trunk/libf/phytitan/clmain.F	(revision 102)
@@ -34,4 +34,5 @@
       USE ioipsl
       USE interface_surf
+      use dimphy
       IMPLICIT none
 c======================================================================
@@ -65,5 +66,4 @@
 c======================================================================
 #include "dimensions.h"
-#include "dimphy.h"
 c$$$ PB ajout pour soil
 #include "dimsoil.h"
@@ -477,4 +477,5 @@
 
       USE interface_surf
+      use dimphy
 
       IMPLICIT none
@@ -484,5 +485,4 @@
 c======================================================================
 #include "dimensions.h"
-#include "dimphy.h"
 #include "YOMCST.h"
 #include "dimsoil.h"
@@ -755,4 +755,6 @@
      e                  paprs,pplay,delp,
      s                  d_ven,flux_v)
+
+      use dimphy
       IMPLICIT none
 c======================================================================
@@ -778,5 +780,4 @@
 c======================================================================
 #include "dimensions.h"
-#include "dimphy.h"
 #include "iniprint.h"
       INTEGER knon
@@ -883,4 +884,6 @@
      .                  ts,u,v,t,
      .                  pcfm, pcfh)
+
+      use dimphy
       IMPLICIT none
 c======================================================================
@@ -903,5 +906,4 @@
 c======================================================================
 #include "dimensions.h"
-#include "dimphy.h"
 #include "YOMCST.h"
 #include "iniprint.h"
@@ -938,7 +940,4 @@
       PARAMETER (prandtl=0.4)
       INTEGER isommet ! le sommet de la couche limite
-c TEST VENUS
-      PARAMETER (isommet=klev)
-c     PARAMETER (isommet=5)
 
       LOGICAL tvirtu ! calculer Ri d'une maniere plus performante
@@ -984,4 +983,6 @@
       DATA appel1er /.TRUE./
 c
+      isommet=klev
+
       IF (appel1er) THEN
         if (prt_level > 9) THEN
@@ -1166,4 +1167,6 @@
       SUBROUTINE coefkz2(knon, paprs, pplay,t,
      .                  pcfm, pcfh)
+
+      use dimphy
       IMPLICIT none
 c======================================================================
@@ -1182,5 +1185,4 @@
 c======================================================================
 #include "dimensions.h"
-#include "dimphy.h"
 #include "YOMCST.h"
 #include "iniprint.h"
Index: /trunk/libf/phytitan/cltrac.F
===================================================================
--- /trunk/libf/phytitan/cltrac.F	(revision 101)
+++ /trunk/libf/phytitan/cltrac.F	(revision 102)
@@ -4,4 +4,6 @@
       SUBROUTINE cltrac(dtime,coef,t,tr,flux,paprs,pplay,delp,
      s                  d_tr)
+
+      use dimphy
       IMPLICIT none
 c======================================================================
@@ -26,5 +28,4 @@
 c======================================================================
 #include "dimensions.h"
-#include "dimphy.h"
       REAL dtime
       REAL coef(klon,klev)
@@ -118,4 +119,11 @@
       ENDDO
 c
+c ATTENTION SHUNTE!!!!!!
+c     DO k = 1, klev
+c     DO i = 1, klon
+c        d_tr(i,k) = 0.
+c     ENDDO
+c     ENDDO
+
       RETURN
       END
Index: /trunk/libf/phytitan/comgeomphy.F90
===================================================================
--- /trunk/libf/phytitan/comgeomphy.F90	(revision 102)
+++ /trunk/libf/phytitan/comgeomphy.F90	(revision 102)
@@ -0,0 +1,23 @@
+module comgeomphy
+   real,save,allocatable :: airephy(:)
+   real,save,allocatable :: cuphy(:)
+   real,save,allocatable :: cvphy(:)
+   real,save,allocatable :: rlatd(:)
+   real,save,allocatable :: rlond(:)
+!$OMP THREADPRIVATE(airephy,cuphy,cvphy,rlatd,rlond)
+contains
+  
+  subroutine initcomgeomphy
+  use dimphy
+  implicit none
+    
+ 
+    allocate(airephy(klon))
+    allocate(cuphy(klon))
+    allocate(cvphy(klon))
+    allocate(rlatd(klon))
+    allocate(rlond(klon))
+
+  end subroutine initcomgeomphy
+  
+end module comgeomphy
Index: /trunk/libf/phytitan/cooling.F
===================================================================
--- /trunk/libf/phytitan/cooling.F	(revision 101)
+++ /trunk/libf/phytitan/cooling.F	(revision 102)
@@ -1,4 +1,3 @@
       SUBROUTINE COOLING(ngrid,NL,PRESS,TEMP,Z,Q0,lwnet,pfluxi)
-      IMPLICIT NONE
 
 c=======================================================================
@@ -52,6 +51,7 @@
 c   ------------
 
+      use dimphy
+      IMPLICIT NONE
 #include "dimensions.h"
-#include "dimphy.h"
 #include "YOMCST.h"
       INTEGER NLAYER,NSPECI,NSPC1I
Index: /trunk/libf/phytitan/diagphy.F
===================================================================
--- /trunk/libf/phytitan/diagphy.F	(revision 101)
+++ /trunk/libf/phytitan/diagphy.F	(revision 102)
@@ -7,4 +7,7 @@
      $    , d_etp_tot, d_qt_tot, d_ec_tot
      $    , fs_bound, fq_bound)
+
+! ATTENTION !! PAS DU TOUT A JOUR POUR VENUS OU TITAN...
+
 C======================================================================
 C
@@ -45,8 +48,8 @@
 C======================================================================
 C 
+      use dimphy
       implicit none
 
 #include "dimensions.h"
-#include "dimphy.h"
 #include "YOMCST.h"
 C
@@ -205,8 +208,8 @@
 c======================================================================
  
+      use dimphy
       IMPLICIT NONE
 C
 #include "dimensions.h"
-#include "dimphy.h"
 #include "YOMCST.h"
 C
Index: /trunk/libf/phytitan/dimphy.F90
===================================================================
--- /trunk/libf/phytitan/dimphy.F90	(revision 102)
+++ /trunk/libf/phytitan/dimphy.F90	(revision 102)
@@ -0,0 +1,40 @@
+MODULE dimphy
+  
+  INTEGER,SAVE :: klon
+  INTEGER,SAVE :: kdlon
+  INTEGER,SAVE :: kfdia
+  INTEGER,SAVE :: kidia
+  INTEGER,SAVE :: klev
+  INTEGER,SAVE :: klevp1
+  INTEGER,SAVE :: klevm1
+  INTEGER,SAVE :: kflev
+
+!$OMP THREADPRIVATE(klon,kfdia,kidia,kdlon)
+  REAL,save,allocatable,dimension(:) :: zmasq
+!$OMP THREADPRIVATE(zmasq)   
+
+CONTAINS
+  
+  SUBROUTINE init_dimphy(klon0,klev0)
+  IMPLICIT NONE
+  
+    INTEGER, INTENT(in) :: klon0
+    INTEGER, INTENT(in) :: klev0
+    
+    klon=klon0
+    
+    kdlon=klon
+    kidia=1
+    kfdia=klon
+!$OMP MASTER 
+    klev=klev0
+    klevp1=klev+1
+    klevm1=klev-1
+    kflev=klev
+!$OMP END MASTER    
+    ALLOCATE(zmasq(klon))    
+    
+  END SUBROUTINE init_dimphy
+
+  
+END MODULE dimphy
Index: /trunk/libf/phytitan/heating.F
===================================================================
--- /trunk/libf/phytitan/heating.F	(revision 101)
+++ /trunk/libf/phytitan/heating.F	(revision 102)
@@ -1,5 +1,3 @@
        SUBROUTINE heating(dist,rmu0,fract,sol_htg,swnet)
-
-      IMPLICIT NONE
 
 
@@ -30,6 +28,7 @@
 c   -------------
 
+      use dimphy
+      IMPLICIT NONE
 #include "dimensions.h"
-#include "dimphy.h"
 
       INTEGER NLEVEL,NLAYER,NSPECV
Index: /trunk/libf/phytitan/hgardfou.F
===================================================================
--- /trunk/libf/phytitan/hgardfou.F	(revision 101)
+++ /trunk/libf/phytitan/hgardfou.F	(revision 102)
@@ -3,10 +3,10 @@
 !
       SUBROUTINE hgardfou (t,tsol,text)
-      IMPLICIT none
 c======================================================================
 c Verifier la temperature
 c======================================================================
+      use dimphy
+      IMPLICIT none
 #include "dimensions.h"
-#include "dimphy.h"
 #include "YOMCST.h"
       REAL t(klon,klev), tsol(klon)
Index: /trunk/libf/phytitan/inicondens.F
===================================================================
--- /trunk/libf/phytitan/inicondens.F	(revision 101)
+++ /trunk/libf/phytitan/inicondens.F	(revision 102)
@@ -9,7 +9,7 @@
 c   -------------
 
+      use dimphy
       IMPLICIT NONE
 #include "dimensions.h"
-#include "dimphy.h"
 #include "YOMCST.h"
 
Index: /trunk/libf/phytitan/iniphysiq.F
===================================================================
--- /trunk/libf/phytitan/iniphysiq.F	(revision 101)
+++ /trunk/libf/phytitan/iniphysiq.F	(revision 102)
@@ -9,5 +9,5 @@
      $           plat,plon,parea,pcu,pcv,
      $           prad,pg,pr,pcpp)
-      IMPLICIT NONE
+
 c
 c=======================================================================
@@ -43,7 +43,8 @@
 c   -------------
  
+      use dimphy
+      USE comgeomphy
+      IMPLICIT NONE
 #include "dimensions.h"
-#include "dimphy.h"
-#include "comgeomphy.h"
 
       REAL prad,pg,pr,pcpp,punjours
Index: /trunk/libf/phytitan/init_phys_lmdz.F90
===================================================================
--- /trunk/libf/phytitan/init_phys_lmdz.F90	(revision 102)
+++ /trunk/libf/phytitan/init_phys_lmdz.F90	(revision 102)
@@ -0,0 +1,19 @@
+!
+!$Header$
+!
+SUBROUTINE init_phys_lmdz(iim,jjp1,llm,nb_proc,distrib)
+  USE mod_grid_phy_lmdz
+  USE dimphy
+  IMPLICIT NONE
+  
+    INTEGER,INTENT(in) :: iim
+    INTEGER,INTENT(in) :: jjp1
+    INTEGER,INTENT(in) :: llm
+    INTEGER,INTENT(in) :: nb_proc
+    INTEGER,INTENT(in) :: distrib(0:nb_proc-1)
+
+
+    CALL init_grid_phy_lmdz(iim,jjp1,llm)
+    CALL init_dimphy(klon,nbp_lev)
+ 
+END SUBROUTINE init_phys_lmdz  
Index: /trunk/libf/phytitan/mod_grid_phy_lmdz.F90
===================================================================
--- /trunk/libf/phytitan/mod_grid_phy_lmdz.F90	(revision 102)
+++ /trunk/libf/phytitan/mod_grid_phy_lmdz.F90	(revision 102)
@@ -0,0 +1,447 @@
+!
+!$Header$
+!
+MODULE mod_grid_phy_lmdz
+  INTEGER,SAVE :: nbp_lon  ! == iim
+  INTEGER,SAVE :: nbp_lat  ! == jjmp1
+  INTEGER,SAVE :: nbp_lev  ! == llm
+  INTEGER,SAVE :: klon_glo
+
+  INTERFACE grid1dTo2d_glo
+    MODULE PROCEDURE grid1dTo2d_glo_i,grid1dTo2d_glo_i1,grid1dTo2d_glo_i2,grid1dTo2d_glo_i3, &
+                     grid1dTo2d_glo_r,grid1dTo2d_glo_r1,grid1dTo2d_glo_r2,grid1dTo2d_glo_r3, &
+		     grid1dTo2d_glo_l,grid1dTo2d_glo_l1,grid1dTo2d_glo_l2,grid1dTo2d_glo_l3
+   END INTERFACE 
+
+   INTERFACE grid2dTo1d_glo
+    MODULE PROCEDURE grid2dTo1d_glo_i,grid2dTo1d_glo_i1,grid2dTo1d_glo_i2,grid2dTo1d_glo_i3, &
+                     grid2dTo1d_glo_r,grid2dTo1d_glo_r1,grid2dTo1d_glo_r2,grid2dTo1d_glo_r3, &
+		     grid2dTo1d_glo_l,grid2dTo1d_glo_l1,grid2dTo1d_glo_l2,grid2dTo1d_glo_l3
+   END INTERFACE 
+ 
+CONTAINS
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!! SUBROUTINE grid1dTo2d  !!  
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+
+  SUBROUTINE init_grid_phy_lmdz(iim,jjp1,llm)
+  IMPLICIT NONE
+  INTEGER, INTENT(in) :: iim
+  INTEGER, INTENT(in) :: jjp1
+  INTEGER, INTENT(in) :: llm
+  
+    nbp_lon=iim
+    nbp_lat=jjp1
+    nbp_lev=llm
+    klon_glo=(iim*jjp1)-2*(iim-1)
+  
+  END SUBROUTINE init_grid_phy_lmdz
+  
+  
+  SUBROUTINE grid1dTo2d_glo_i(VarIn,VarOut)  
+  IMPLICIT NONE  
+    INTEGER,INTENT(IN),DIMENSION(:)     :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:)  :: VarOut
+    
+    CALL grid1dTo2d_glo_igen(VarIn,VarOut,1)
+  
+  END SUBROUTINE grid1dTo2d_glo_i
+  
+
+  SUBROUTINE grid1dTo2d_glo_i1(VarIn,VarOut)  
+  IMPLICIT NONE  
+    INTEGER,INTENT(IN),DIMENSION(:,:)     :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:,:)  :: VarOut
+    
+    CALL grid1dTo2d_glo_igen(VarIn,VarOut,size(VarIn,2))
+  
+  END SUBROUTINE grid1dTo2d_glo_i1
+
+  SUBROUTINE grid1dTo2d_glo_i2(VarIn,VarOut)  
+  IMPLICIT NONE  
+    INTEGER,INTENT(IN),DIMENSION(:,:,:)     :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:,:,:)  :: VarOut
+    
+    CALL grid1dTo2d_glo_igen(VarIn,VarOut,size(VarIn,2)*size(VarIn,3))
+  
+  END SUBROUTINE grid1dTo2d_glo_i2
+  
+  SUBROUTINE grid1dTo2d_glo_i3(VarIn,VarOut)  
+  IMPLICIT NONE  
+    INTEGER,INTENT(IN),DIMENSION(:,:,:,:)     :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:,:,:,:)  :: VarOut
+    
+    CALL grid1dTo2d_glo_igen(VarIn,VarOut,size(VarIn,2)*size(VarIn,3)*size(VarIn,4))
+  
+  END SUBROUTINE grid1dTo2d_glo_i3
+
+
+  SUBROUTINE grid1dTo2d_glo_r(VarIn,VarOut)  
+  IMPLICIT NONE  
+    REAL,INTENT(IN),DIMENSION(:)     :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:)  :: VarOut
+    
+    CALL grid1dTo2d_glo_rgen(VarIn,VarOut,1)
+  
+  END SUBROUTINE grid1dTo2d_glo_r
+  
+
+  SUBROUTINE grid1dTo2d_glo_r1(VarIn,VarOut)  
+  IMPLICIT NONE  
+    REAL,INTENT(IN),DIMENSION(:,:)     :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:,:)  :: VarOut
+    
+    CALL grid1dTo2d_glo_rgen(VarIn,VarOut,size(VarIn,2))
+  
+  END SUBROUTINE grid1dTo2d_glo_r1
+
+  SUBROUTINE grid1dTo2d_glo_r2(VarIn,VarOut)  
+  IMPLICIT NONE  
+    REAL,INTENT(IN),DIMENSION(:,:,:)     :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:,:,:)  :: VarOut
+    
+    CALL grid1dTo2d_glo_rgen(VarIn,VarOut,size(VarIn,2)*size(VarIn,3))
+  
+  END SUBROUTINE grid1dTo2d_glo_r2
+  
+  SUBROUTINE grid1dTo2d_glo_r3(VarIn,VarOut)  
+  IMPLICIT NONE  
+    REAL,INTENT(IN),DIMENSION(:,:,:,:)     :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:,:,:,:)  :: VarOut
+    
+    CALL grid1dTo2d_glo_rgen(VarIn,VarOut,size(VarIn,2)*size(VarIn,3)*size(VarIn,4))
+  
+  END SUBROUTINE grid1dTo2d_glo_r3
+  
+  
+  
+  SUBROUTINE grid1dTo2d_glo_l(VarIn,VarOut)  
+  IMPLICIT NONE  
+    LOGICAL,INTENT(IN),DIMENSION(:)     :: VarIn
+    LOGICAL,INTENT(OUT),DIMENSION(:,:)  :: VarOut
+    
+    CALL grid1dTo2d_glo_lgen(VarIn,VarOut,1)
+  
+  END SUBROUTINE grid1dTo2d_glo_l
+  
+
+  SUBROUTINE grid1dTo2d_glo_l1(VarIn,VarOut)  
+  IMPLICIT NONE  
+    LOGICAL,INTENT(IN),DIMENSION(:,:)     :: VarIn
+    LOGICAL,INTENT(OUT),DIMENSION(:,:,:)  :: VarOut
+    
+    CALL grid1dTo2d_glo_lgen(VarIn,VarOut,size(VarIn,2))
+  
+  END SUBROUTINE grid1dTo2d_glo_l1
+
+  SUBROUTINE grid1dTo2d_glo_l2(VarIn,VarOut)  
+  IMPLICIT NONE  
+    LOGICAL,INTENT(IN),DIMENSION(:,:,:)     :: VarIn
+    LOGICAL,INTENT(OUT),DIMENSION(:,:,:,:)  :: VarOut
+    
+    CALL grid1dTo2d_glo_lgen(VarIn,VarOut,size(VarIn,2)*size(VarIn,3))
+  
+  END SUBROUTINE grid1dTo2d_glo_l2
+  
+  SUBROUTINE grid1dTo2d_glo_l3(VarIn,VarOut)  
+  IMPLICIT NONE  
+    LOGICAL,INTENT(IN),DIMENSION(:,:,:,:)     :: VarIn
+    LOGICAL,INTENT(OUT),DIMENSION(:,:,:,:,:)  :: VarOut
+    
+    CALL grid1dTo2d_glo_lgen(VarIn,VarOut,size(VarIn,2)*size(VarIn,3)*size(VarIn,4))
+  
+  END SUBROUTINE grid1dTo2d_glo_l3  
+  
+    SUBROUTINE grid2dTo1d_glo_i(VarIn,VarOut)  
+  IMPLICIT NONE  
+    INTEGER,INTENT(IN),DIMENSION(:,:) :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:)  :: VarOut
+    
+    CALL grid2dTo1d_glo_igen(VarIn,VarOut,1)
+  
+  END SUBROUTINE grid2dTo1d_glo_i
+  
+
+  SUBROUTINE grid2dTo1d_glo_i1(VarIn,VarOut)  
+  IMPLICIT NONE  
+    INTEGER,INTENT(IN),DIMENSION(:,:,:) :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:)  :: VarOut
+    
+    CALL grid2dTo1d_glo_igen(VarIn,VarOut,size(VarIn,3))
+  
+  END SUBROUTINE grid2dTo1d_glo_i1
+
+  SUBROUTINE grid2dTo1d_glo_i2(VarIn,VarOut)  
+  IMPLICIT NONE  
+    INTEGER,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:,:)  :: VarOut
+    
+    CALL grid2dTo1d_glo_igen(VarIn,VarOut,size(VarIn,3)*size(VarIn,4))
+  
+  END SUBROUTINE grid2dTo1d_glo_i2
+  
+  SUBROUTINE grid2dTo1d_glo_i3(VarIn,VarOut)  
+  IMPLICIT NONE  
+    INTEGER,INTENT(IN),DIMENSION(:,:,:,:,:) :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:,:,:)  :: VarOut
+    
+    CALL grid2dTo1d_glo_igen(VarIn,VarOut,size(VarIn,3)*size(VarIn,4)*size(VarIn,5))
+  
+  END SUBROUTINE grid2dTo1d_glo_i3
+ 
+
+
+
+  SUBROUTINE grid2dTo1d_glo_r(VarIn,VarOut)  
+  IMPLICIT NONE  
+    REAL,INTENT(IN),DIMENSION(:,:) :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:)  :: VarOut
+    
+    CALL grid2dTo1d_glo_rgen(VarIn,VarOut,1)
+  
+  END SUBROUTINE grid2dTo1d_glo_r
+  
+
+  SUBROUTINE grid2dTo1d_glo_r1(VarIn,VarOut)  
+  IMPLICIT NONE  
+    REAL,INTENT(IN),DIMENSION(:,:,:) :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:)  :: VarOut
+    
+    CALL grid2dTo1d_glo_rgen(VarIn,VarOut,size(VarIn,3))
+  
+  END SUBROUTINE grid2dTo1d_glo_r1
+
+  SUBROUTINE grid2dTo1d_glo_r2(VarIn,VarOut)  
+  IMPLICIT NONE  
+    REAL,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:,:)  :: VarOut
+    
+    CALL grid2dTo1d_glo_rgen(VarIn,VarOut,size(VarIn,3)*size(VarIn,4))
+  
+  END SUBROUTINE grid2dTo1d_glo_r2
+  
+  SUBROUTINE grid2dTo1d_glo_r3(VarIn,VarOut)  
+  IMPLICIT NONE  
+    REAL,INTENT(IN),DIMENSION(:,:,:,:,:) :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:,:,:)  :: VarOut
+    
+    CALL grid2dTo1d_glo_rgen(VarIn,VarOut,size(VarIn,3)*size(VarIn,4)*size(VarIn,5))
+  
+  END SUBROUTINE grid2dTo1d_glo_r3
+
+
+
+  SUBROUTINE grid2dTo1d_glo_l(VarIn,VarOut)  
+  IMPLICIT NONE  
+    LOGICAL,INTENT(IN),DIMENSION(:,:) :: VarIn
+    LOGICAL,INTENT(OUT),DIMENSION(:)  :: VarOut
+    
+    CALL grid2dTo1d_glo_lgen(VarIn,VarOut,1)
+  
+  END SUBROUTINE grid2dTo1d_glo_l
+  
+
+  SUBROUTINE grid2dTo1d_glo_l1(VarIn,VarOut)  
+  IMPLICIT NONE  
+    LOGICAL,INTENT(IN),DIMENSION(:,:,:) :: VarIn
+    LOGICAL,INTENT(OUT),DIMENSION(:,:)  :: VarOut
+    
+    CALL grid2dTo1d_glo_lgen(VarIn,VarOut,size(VarIn,3))
+  
+  END SUBROUTINE grid2dTo1d_glo_l1
+
+  SUBROUTINE grid2dTo1d_glo_l2(VarIn,VarOut)  
+  IMPLICIT NONE  
+    LOGICAL,INTENT(IN),DIMENSION(:,:,:,:) :: VarIn
+    LOGICAL,INTENT(OUT),DIMENSION(:,:,:)  :: VarOut
+    
+    CALL grid2dTo1d_glo_lgen(VarIn,VarOut,size(VarIn,3)*size(VarIn,4))
+  
+  END SUBROUTINE grid2dTo1d_glo_l2
+  
+  SUBROUTINE grid2dTo1d_glo_l3(VarIn,VarOut)  
+  IMPLICIT NONE  
+    LOGICAL,INTENT(IN),DIMENSION(:,:,:,:,:) :: VarIn
+    LOGICAL,INTENT(OUT),DIMENSION(:,:,:,:)  :: VarOut
+    
+    CALL grid2dTo1d_glo_lgen(VarIn,VarOut,size(VarIn,3)*size(VarIn,4)*size(VarIn,5))
+  
+  END SUBROUTINE grid2dTo1d_glo_l3
+
+END MODULE mod_grid_phy_lmdz
+
+
+  
+  SUBROUTINE grid1dTo2d_glo_igen(VarIn,VarOut,dimsize)
+    USE mod_grid_phy_lmdz
+    IMPLICIT NONE
+
+    INTEGER,INTENT(IN) :: dimsize
+    INTEGER,INTENT(IN) ,DIMENSION(klon_glo,dimsize)       :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(nbp_lon*nbp_lat,dimsize)  :: VarOut
+    INTEGER :: i,ij,Offset
+
+    
+    Offset=nbp_lon
+        
+    DO i=1,dimsize
+      DO ij=1,klon_glo
+        VarOut(ij+offset-1,i)=VarIn(ij,i)
+      ENDDO
+    ENDDO
+    
+    
+    DO i=1,dimsize
+      DO ij=1,nbp_lon
+       VarOut(ij,i)=VarIn(1,i)
+      ENDDO
+    ENDDO
+    
+    
+    DO i=1,dimsize
+      DO ij=nbp_lon*(nbp_lat-1)+1,nbp_lat*nbp_lon
+       VarOut(ij,i)=VarIn(klon_glo,i)
+      ENDDO
+    ENDDO
+
+  END SUBROUTINE grid1dTo2d_glo_igen   
+
+
+  SUBROUTINE grid1dTo2d_glo_rgen(VarIn,VarOut,dimsize)
+    USE mod_grid_phy_lmdz
+    IMPLICIT NONE
+
+    INTEGER,INTENT(IN) :: dimsize
+    REAL,INTENT(IN) ,DIMENSION(klon_glo,dimsize)       :: VarIn
+    REAL,INTENT(OUT),DIMENSION(nbp_lon*nbp_lat,dimsize)  :: VarOut
+    INTEGER :: i,ij,Offset
+
+   
+    Offset=nbp_lon
+        
+    DO i=1,dimsize
+      DO ij=1,klon_glo
+        VarOut(ij+offset-1,i)=VarIn(ij,i)
+      ENDDO
+    ENDDO
+    
+    
+    DO i=1,dimsize
+      DO ij=1,nbp_lon
+       VarOut(ij,i)=VarIn(1,i)
+      ENDDO
+    ENDDO
+    
+    
+    DO i=1,dimsize
+      DO ij=nbp_lon*(nbp_lat-1)+1,nbp_lat*nbp_lon
+       VarOut(ij,i)=VarIn(klon_glo,i)
+      ENDDO
+    ENDDO
+
+  END SUBROUTINE grid1dTo2d_glo_rgen   
+
+  SUBROUTINE grid1dTo2d_glo_lgen(VarIn,VarOut,dimsize)
+    USE mod_grid_phy_lmdz
+    IMPLICIT NONE
+    
+    INTEGER,INTENT(IN) :: dimsize
+    LOGICAL,INTENT(IN) ,DIMENSION(klon_glo,dimsize)       :: VarIn
+    LOGICAL,INTENT(OUT),DIMENSION(nbp_lon*nbp_lat,dimsize)  :: VarOut
+    INTEGER :: i,ij,Offset
+
+    Offset=nbp_lon
+        
+    DO i=1,dimsize
+      DO ij=1,klon_glo
+        VarOut(ij+offset-1,i)=VarIn(ij,i)
+      ENDDO
+    ENDDO
+    
+    
+    DO i=1,dimsize
+      DO ij=1,nbp_lon
+       VarOut(ij,i)=VarIn(1,i)
+      ENDDO
+    ENDDO
+    
+    
+    DO i=1,dimsize
+      DO ij=nbp_lon*(nbp_lat-1)+1,nbp_lat*nbp_lon
+       VarOut(ij,i)=VarIn(klon_glo,i)
+      ENDDO
+    ENDDO
+
+  END SUBROUTINE grid1dTo2d_glo_lgen     
+  
+  
+  SUBROUTINE grid2dTo1d_glo_igen(VarIn,VarOut,dimsize)
+    USE mod_grid_phy_lmdz
+    IMPLICIT NONE
+
+    INTEGER,INTENT(IN) :: dimsize
+    INTEGER,INTENT(IN) ,DIMENSION(nbp_lon*nbp_lat,dimsize) :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(klon_glo,dimsize)      :: VarOut
+    INTEGER :: i,ij,offset
+
+    offset=nbp_lon
+
+    DO i=1,dimsize
+      DO ij=1,klon_glo
+        VarOut(ij,i)=VarIn(ij+offset-1,i)
+      ENDDO
+    ENDDO
+
+    DO i=1,dimsize
+      VarOut(1,i)=VarIn(1,i)
+    ENDDO
+    
+  END SUBROUTINE grid2dTo1d_glo_igen   
+  
+  SUBROUTINE grid2dTo1d_glo_rgen(VarIn,VarOut,dimsize)
+    USE mod_grid_phy_lmdz
+    IMPLICIT NONE
+
+    INTEGER,INTENT(IN) :: dimsize
+    REAL,INTENT(IN) ,DIMENSION(nbp_lon*nbp_lat,dimsize) :: VarIn
+    REAL,INTENT(OUT),DIMENSION(klon_glo,dimsize)      :: VarOut
+    INTEGER :: i,ij,offset
+
+    offset=nbp_lon
+
+    DO i=1,dimsize
+      DO ij=1,klon_glo
+        VarOut(ij,i)=VarIn(ij+offset-1,i)
+      ENDDO
+    ENDDO
+
+    DO i=1,dimsize
+      VarOut(1,i)=VarIn(1,i)
+    ENDDO
+    
+  END SUBROUTINE grid2dTo1d_glo_rgen 
+    
+  SUBROUTINE grid2dTo1d_glo_lgen(VarIn,VarOut,dimsize)
+    USE mod_grid_phy_lmdz
+    IMPLICIT NONE
+
+    INTEGER,INTENT(IN) :: dimsize
+    LOGICAL,INTENT(IN) ,DIMENSION(nbp_lon*nbp_lat,dimsize) :: VarIn
+    LOGICAL,INTENT(OUT),DIMENSION(klon_glo,dimsize)      :: VarOut
+    INTEGER :: i,ij,offset
+
+    offset=nbp_lon
+
+    DO i=1,dimsize
+      DO ij=1,klon_glo
+        VarOut(ij,i)=VarIn(ij+offset-1,i)
+      ENDDO
+    ENDDO
+
+    DO i=1,dimsize
+      VarOut(1,i)=VarIn(1,i)
+    ENDDO
+    
+  END SUBROUTINE grid2dTo1d_glo_lgen   
Index: /trunk/libf/phytitan/optci.F
===================================================================
--- /trunk/libf/phytitan/optci.F	(revision 101)
+++ /trunk/libf/phytitan/optci.F	(revision 102)
@@ -1,5 +1,5 @@
       SUBROUTINE OPTCI(ykim,nmicro,IPRINT)
+      use dimphy
 #include "dimensions.h"
-#include "dimphy.h"
 #include "microtab.h"
 #include "numchimrad.h"
Index: /trunk/libf/phytitan/optci_1pt.F
===================================================================
--- /trunk/libf/phytitan/optci_1pt.F	(revision 101)
+++ /trunk/libf/phytitan/optci_1pt.F	(revision 102)
@@ -2,6 +2,6 @@
      .            COSBI_1pt,DTAUI_1pt,TAUHI_1pt,TAUHID_1pt,TAUCI_1pt,
      .            TAUGI_1pt,TAUGID_1pt,WBARI_1pt,TAUI_1pt,IPRINT)
+      use dimphy
 #include "dimensions.h"
-#include "dimphy.h"
 #include "microtab.h"
 #include "numchimrad.h"
Index: /trunk/libf/phytitan/optcv.F
===================================================================
--- /trunk/libf/phytitan/optcv.F	(revision 101)
+++ /trunk/libf/phytitan/optcv.F	(revision 102)
@@ -2,6 +2,6 @@
 
 
+      use dimphy
 #include "dimensions.h"
-#include "dimphy.h"
 #include "microtab.h"
 #include "clesphys.h"
Index: /trunk/libf/phytitan/optcv_1pt.F
===================================================================
--- /trunk/libf/phytitan/optcv_1pt.F	(revision 101)
+++ /trunk/libf/phytitan/optcv_1pt.F	(revision 102)
@@ -4,6 +4,6 @@
 
 
+      use dimphy
 #include "dimensions.h"
-#include "dimphy.h"
 #include "microtab.h"
 #include "clesphys.h"
